drawing = false;
mode = 0;

prevx = 0;
prevy = 0;

point = "rgb(255,100,100)";
stroke = "rgb(100,255,100)";
fill = "rgb(100,100,255)";

function getContext (){
    return document.getElementById('myCanvas').getContext('2d');
}

function start(ev){
    drawing = true;
    switch(mode){
    case 0:
        rect(ev.clientX-1,ev.clientY-1,2,2,point);
        break;
    case 1:
        rect(ev.clientX-1,ev.clientY-1,2,2,point);
        prevx = ev.clientX; prevy = ev.clientY;
        break;
    case 2:
        rect(ev.clientX,ev.clientY,1,1,point);
        prevx = ev.clientX; prevy = ev.clientY;
        break;
    }
}

function drag(ev){
    if(drawing){
    switch(mode){
    case 0:
        rect(ev.clientX-1,ev.clientY-1,2,2,point);
        break;
    case 1:
        line(prevx,prevy,ev.clientX,ev.clientY);
        prevx = ev.clientX; prevy = ev.clientY;
        rect(ev.clientX-1,ev.clientY-1,2,2,point);
        break;
    case 2:
        break;
    }
    }
}

function end(ev){
    if(drawing){
        drawing = false;
        switch(mode){
        case 0:
            rect(ev.clientX-1,ev.clientY-1,2,2,point);
            break;
        case 1:
            line(prevx,prevy,ev.clientX,ev.clientY);
            prevx = ev.clientX; prevy = ev.clientY;
            rect(ev.clientX-1,ev.clientY-1,2,2,point);
            break;
        case 2:
            (getContext()).clearRect(prevx,prevy,1,1);
            rect(prevx,prevy,ev.clientX - prevx,ev.clientY - prevy,fill);
        }
    }
}

// drawing functions
function line(fx,fy,tx,ty){
    var ctx = getContext();
    ctx.strokeStyle = stroke;
    ctx.beginPath();
    ctx.moveTo(fx,fy);
    ctx.lineTo(tx,ty);
    ctx.stroke();
}
function rect(fx,fy,w,h,style){
    var ctx = getContext();
    ctx.fillStyle = style;
    ctx.fillRect(fx,fy,w,h);
}


function init(){
    var c = document.getElementById("myCanvas");
    c.addEventListener("mousedown", start, true);
    c.addEventListener("mousemove", drag, true);
    c.addEventListener("mouseup", end, true);
};
